<?php

declare(strict_types=1);

namespace FiloBlu\Checkproducts\Model;

use Magento\Catalog\Api\Data\ProductInterface;

/**
 *
 */
interface ProductCheckerInterface
{
    /**
     * @param \FiloBlu\Checkproducts\Model\CollectorInterface $collector
     * @return \FiloBlu\Checkproducts\Model\CollectorInterface
     */
    public function check(CollectorInterface $collector) : CollectorInterface;

    /**
     * @param \Magento\Catalog\Api\Data\ProductInterface $product
     * @param \FiloBlu\Checkproducts\Model\CollectorInterface $collector
     * @return bool
     */
    public function validate(ProductInterface $product, CollectorInterface $collector): bool;

}